package builtin;

import runEnv.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

public class MemoryComponent extends Component {

	JFrame frame;
	JTextField textField;
	long opdValue;
	long initValue;
	boolean visibleValue;

	private ActionListener textInfoListener = new ActionListener() {
		public void actionPerformed( ActionEvent event ) {
			int base = runEnv().getValue( "base" ).intValue();
			try {
				opdValue = Long.parseLong( textField.getText(), base );
				schedule();
				}
			catch ( NumberFormatException exception ) {
				}
			}
		};
	
	public MemoryComponent( RunEnv runEnv ) {
		super( runEnv );
		String name = runEnv().getValue( "name" ).stringValue();
		int x = runEnv().getValue( "x" ).intValue();
		int y = runEnv().getValue( "y" ).intValue();
		initValue = runEnv().getValue( "initValue" ).intValue();
		frame = new JFrame( "" + name );
		textField = new JTextField( 20 );
		Container contentPane = frame.getContentPane();
		textField.addActionListener( textInfoListener );
		contentPane.add( textField );
		frame.setLocation( x, y );
		frame.validate();
		frame.pack();
		frame.setVisible( true );
		frame.toFront();
		}
		
	public void compute() {
//		System.err.println( "Compute MemoryComponent " + this );
		PathArrayValue read = runEnv().getValue( "read" ).pathArrayValue();
		PathArrayValue write = runEnv().getValue( "write" ).pathArrayValue();
		PathArrayValue init = runEnv().getValue( "init" ).pathArrayValue();
		PathArrayValue visible = runEnv().getValue( "visible" ).pathArrayValue();
		boolean doRead = read.elementAt( 0 ).getValue();
		boolean doWrite = write.elementAt( 0 ).getValue();
		boolean setInit = init.elementAt( 0 ).getValue();
		boolean setVisible = visible.elementAt( 0 ).getValue();
		if ( doRead ) {
			PathArrayValue result = runEnv().getValue( "result" ).pathArrayValue();
			result.setValue( opdValue );
			}
		if ( doWrite ) {
			PathArrayValue opd = runEnv().getValue( "opd" ).pathArrayValue();		
			opdValue = opd.getValue();
			int base = runEnv().getValue( "base" ).intValue();
			String textValue = Long.toString( opdValue, base );
			textField.setText( textValue );
			textField.invalidate();
			frame.validate();
			}
		if ( setInit ) {
			PathArrayValue result = runEnv().getValue( "result" ).pathArrayValue();
			opdValue = initValue;
			result.setValue( opdValue );
			}
		if ( visibleValue != setVisible ) {
			visibleValue = setVisible;
			if ( setVisible ) {
				frame.setVisible( true );
				frame.toFront();
				}
			else {
				frame.setVisible( false );
				}
			}
		}
	
	public String toString() {
		String name = runEnv().getValue( "name" ).stringValue();
		return name;
		}
	
	}
