package node.declNode.componentDeclNode;

import runEnv.*;
import builtin.*;
import text.*;

public class EmptyBodyNode extends BodyNode {

	public EmptyBodyNode() {
		}

	public String toString() {
		return ";";
		}

	public void eval( RunEnv runEnv ) {
		Print.interp().println( runEnv );
		String name = runEnv.name();
		Component component;
		if ( name.equals( "literal" ) )
			component = new LiteralComponent( runEnv );
		else if ( name.equals( "counter" ) )
			component = new CounterComponent( runEnv );
		else if ( name.equals( "input" ) )
			component = new InputComponent( runEnv );
		else if ( name.equals( "output" ) )
			component = new OutputComponent( runEnv );
		else if ( name.equals( "memory" ) )
			component = new MemoryComponent( runEnv );

		else if ( name.equals( "or" ) )
			component = new OrComponent( runEnv );
		else if ( name.equals( "and" ) )
			component = new AndComponent( runEnv );
		else if ( name.equals( "xor" ) )
			component = new XorComponent( runEnv );

		else if ( name.equals( "not" ) )
			component = new NotComponent( runEnv );
		else if ( name.equals( "join" ) )
			component = new JoinComponent( runEnv );
		else if ( name.equals( "select" ) )
			component = new SelectComponent( runEnv );
		else if ( name.equals( "decode" ) )
			component = new DecodeComponent( runEnv );
		else
			throw new Error( "Unknown built-in component " + name );
		component.start();
		}
		
	}
