package node.exprNode;

import node.*;

import runEnv.*;
import runEnv.basicValue.*;

public class CondNode extends ExprNode {

	private ExprNode cond;
	private ExprNode thenPart;
	private ExprNode elsePart;
	
	public CondNode(
		ExprNode cond,
		ExprNode thenPart,
		ExprNode elsePart ) {
		this.cond = cond;
		this.thenPart = thenPart;
		this.elsePart = elsePart;
		}

	public String toString() {
		return 
			cond.toString( precedence + 1 ) 
			+ " ? " +  thenPart.toString( precedence ) 
			+ " : " + elsePart.toString( precedence );
		}

	public RunValue eval( RunEnv runEnv ) {
		boolean condValue = cond.eval( runEnv ).boolValue();
		if ( condValue )
			return thenPart.eval( runEnv );
		else
			return elsePart.eval( runEnv );
		}

	}
