package node.exprNode;

import node.*;

import runEnv.*;

public abstract class ExprNode extends Node {
	public final static int PREC_COND		=	2;
	public final static int PREC_OR			=	4;
	public final static int PREC_AND		=	5;
	public final static int PREC_EQ			=	9;
	public final static int PREC_REL		=	9;
	public final static int PREC_SHIFT		=	11;
	public final static int PREC_ADD		=	12;
	public final static int PREC_MUL		=	13;
	public final static int PREC_PREFIX		=	15;
	public final static int PREC_PRIMARY	=	17;

	protected int precedence;

	public String toString( int parentPrec ) {
		if ( precedence < parentPrec )
			return "( " + toString() + " )";
		else
			return toString();
		}
	
	public abstract RunValue eval( RunEnv runEnv );

	}
