package node.exprNode.binaryNode.arithNode;

import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;

import runEnv.*;
import runEnv.basicValue.*;

public class DivideNode extends ArithNode {

	public DivideNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_MUL;
		operator = "/";
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		return new IntValue( leftValue.intValue() / rightValue.intValue() );
		}
	}
