package node.exprNode.valueNode;
import node.*;
import node.exprNode.*;

import runEnv.*;
import runEnv.basicValue.*;

public class IntValueNode extends ValueNode {

	private int base;
	private int value;

	public IntValueNode( int base, int value ) {
		this.base = base;
		this.value = value;
		}

	public String toString() {
		switch ( base ) {
			case 2:
				return "0b" + Integer.toBinaryString( value );
			case 10:
				return "" + value;
			case 16:
				return "0x" + Integer.toHexString( value );
			default:
				throw new Error( "Invalid base of " + base );
			}
		}

	public RunValue eval( RunEnv runEnv ) {
		return new IntValue( value );
		}

	}
