package node.pathNode.pathNameNode;

import node.exprNode.*;

import runEnv.*;

public class IndexPathNameNode extends PathNameNode {

	private String ident;
	private ExprNode index;

	public IndexPathNameNode( 
		String ident,
		ExprNode index ) {
		this.ident = ident;
		this.index = index;
		}

	public String toString() {
		return ident + "[ " + index + " ]";
		}

	public PathArrayValue eval( RunEnv runEnv ) {
		PathArrayValue pathArray = runEnv.getValue( ident ).pathArrayValue();
		int indexValue = index.eval( runEnv ).intValue();
//		System.err.println( "Indexing " + pathArray + "[ " + indexValue + " ]" );
		return pathArray.index( indexValue );
		}
	}