package node.pathNode.pathNameNode;

import node.exprNode.*;

import runEnv.*;

public class SubArrayPathNameNode extends PathNameNode {

	private String ident;
	private ExprNode size;
	private ExprNode base;

	public SubArrayPathNameNode( 
		String ident,
		ExprNode size,
		ExprNode base ) {
		this.ident = ident;
		this.size = size;
		this.base = base;
		}

	public String toString() {
		return ident + "[ " + size + "@" + base + " ]";
		}

	public PathArrayValue eval( RunEnv runEnv ) {
		PathArrayValue pathArray = runEnv.getValue( ident ).pathArrayValue();
		int sizeValue = size.eval( runEnv ).intValue();
		int baseValue = base.eval( runEnv ).intValue();
		return pathArray.subArray( baseValue, sizeValue );
		}
	}