package node.stmtNode.forStmtNode;

import node.*;
import node.stmtNode.*;
import node.exprNode.*;

import runEnv.*;
import runEnv.basicValue.*;

public class ForStmtNode extends StmtNode {

	private String ident;
	private ExprNode fromExpr;
	private ExprNode toExpr;
	private DeclStmtListNode doPart;
	
	public ForStmtNode(
		String ident,
		ExprNode fromExpr,
		ExprNode toExpr,
		DeclStmtListNode doPart
		) {
		this.ident = ident;
		this.fromExpr = fromExpr;
		this.toExpr = toExpr;
		this.doPart = doPart;
		}
	
	public String toString() {
		return 
			"for " + ident + " from " + fromExpr + " upto " + toExpr 
			+ "%ndo%n%+" + doPart + "%-%nend";
		}

	public void eval( RunEnv runEnv ) {
		int fromValue = fromExpr.eval( runEnv ).intValue();
		int toValue = toExpr.eval( runEnv ).intValue();
		for ( int i = fromValue; i < toValue; i++ ) {
			RunEnv localEnv = new RunEnv( "for " + ident, runEnv );
			localEnv.declare( RunDecl.VALUE, ident, new IntValue( i ) );
			doPart.eval( localEnv );
			}
		}

	}
