package node.stmtNode.ifStmtNode;

import node.*;
import node.stmtNode.*;
import node.stmtNode.ifStmtNode.elseOptNode.*;
import node.exprNode.*;

import runEnv.*;

public class IfStmtNode extends StmtNode {

	private ExprNode cond;
	private DeclStmtListNode thenPart;
	private ElseOptNode elsePart;

	public IfStmtNode( 
		ExprNode cond, 
		DeclStmtListNode thenPart, 
		ElseOptNode elsePart ) {
		this.cond = cond;
		this.thenPart = thenPart;
		this.elsePart = elsePart;
		}

	public String toString() {
		return "if " + cond + "%nthen%+%n" 
			+ thenPart + "%-" + elsePart + "%nend";
		}

	public void eval( RunEnv runEnv ) {
		if ( cond.eval( runEnv ).boolValue() ) {
			RunEnv localEnv = new RunEnv( "then", runEnv );
			thenPart.eval( localEnv );
			}
		else {
			elsePart.eval( runEnv );
			}
		}

	}
