package node.stmtNode.ifStmtNode.elseOptNode;

import node.*;
import node.stmtNode.*;
import node.exprNode.*;

import runEnv.*;

public class ElseOpt2Node extends ElseOptNode {

	private ExprNode cond;
	private DeclStmtListNode thenPart;
	private ElseOptNode elsePart;

	public ElseOpt2Node( 
		ExprNode cond, 
		DeclStmtListNode thenPart, 
		ElseOptNode elsePart ) {
		this.cond = cond;
		this.thenPart = thenPart;
		this.elsePart = elsePart;
		}

	public String toString() {
		return "%nelif " + cond + "%nthen%+%n" 
			+ thenPart + "%-" + elsePart;
		}

	public void eval( RunEnv runEnv ) {
		if ( cond.eval( runEnv ).boolValue() ) {
			RunEnv localEnv = new RunEnv( "then", runEnv );
			thenPart.eval( localEnv );
			}
		else
			elsePart.eval( runEnv );
		}

	}
