package node.stmtNode.invocationStmtNode;

import node.*;
import node.exprNode.*;
import node.pathNode.*;
import node.declNode.componentDeclNode.*;
import node.declNode.pathDefnNode.*;
import node.declNode.valueDefnNode.*;

import runEnv.*;

import text.*;

public class InvocListNode extends ListNode< InvocNode > {
	
	public InvocListNode() {
		super( "." );
		}
	
	public InvocListNode( InvocNode node ) {
		this();
		addElement( node );
		}
		
	public void eval( 
		RunEnv runEnv, 
		PathArrayValue[] firstParamValues, 
		PathArrayValue[] lastParamValues ) {

		PathArrayValue[] inputParamValues = null;
		PathArrayValue[] outputParamValues = null;

		for ( int i = 0; i < size(); i++ ) {
			InvocNode invocNode = elementAt( i );
			String ident = invocNode.ident();
			
			if ( i == 0 )
				inputParamValues = firstParamValues;
			else
				inputParamValues = outputParamValues;
				
			if ( i == size() - 1 )
				outputParamValues = lastParamValues;
			else {
				ComponentValue componentValue = runEnv.getValue( ident ).componentValue();
				outputParamValues = 
					new PathArrayValue[ 
						componentValue.componentDecl().outputParamDecl().size() ];
				}
				
			invocNode.eval( runEnv, inputParamValues, outputParamValues );
			}
		}

	}
