package node.stmtNode.invocationStmtNode;

import node.*;
import node.exprNode.*;
import node.pathNode.*;

import runEnv.*;

public class InvocNode extends Node {

	private String ident;
	private ExprListNode valueParams;
	public String ident() { return ident; }
	public ExprListNode valueParams() { return valueParams; }
	
	public InvocNode( 
		String ident,
		ExprListNode valueParams ) {
		this.ident = ident;
		this.valueParams = valueParams;
		}

	public String toString() {
		String valueParamsText = "";
		if ( valueParams.size() != 0 )
			valueParamsText = "( " + valueParams + " )";
		return ident + valueParamsText;
		}
	
	public void eval( 
		RunEnv runEnv, 
		PathArrayValue[] inputParamValues, 
		PathArrayValue[] outputParamValues ) {
		ComponentValue componentValue = runEnv.getValue( ident ).componentValue();
		RunValue[] paramValues = valueParams.eval( runEnv );
		componentValue.eval( inputParamValues, paramValues, outputParamValues );
		}

	}
