package node.stmtNode.invocationStmtNode;

import node.stmtNode.*;
import node.exprNode.*;
import node.pathNode.*;
import node.declNode.componentDeclNode.*;
import node.declNode.pathDefnNode.*;
import node.declNode.valueDefnNode.*;

import runEnv.*;

public class InvocationStmtNode extends StmtNode {

	private PathArrayListNode inputParams;
	private InvocListNode invocList;
	private PathArrayListNode outputParams;

	public InvocationStmtNode( 
		PathArrayListNode inputParams, 
		InvocListNode invocList, 
		PathArrayListNode outputParams ) {
		this.inputParams = inputParams;
		this.invocList = invocList;
		this.outputParams = outputParams;
		}

	public String toString() {
		String inputParamsText = "";
		String outputParamsText = "";
		if ( inputParams.size() != 0 )
			inputParamsText = "{ in " + inputParams + " } ";
		if ( outputParams.size() != 0 )
			outputParamsText = " { out " + outputParams + " }";
		return inputParamsText + invocList + outputParamsText + ";";
		}

	public void eval( RunEnv runEnv ) {
		PathArrayValue[] inputParamValues = inputParams.eval( runEnv );
		PathArrayValue[] outputParamValues = outputParams.eval( runEnv );
		invocList.eval( runEnv, inputParamValues, outputParamValues );
		}

	}
