package runEnv;

import node.declNode.componentDeclNode.*;

public class ComponentValue extends RunValue {

	private ComponentDeclNode componentDecl;
	private RunEnv enclosingEnv;
	
	public ComponentDeclNode componentDecl() { return componentDecl; }

	public ComponentValue( ComponentDeclNode componentDecl, RunEnv enclosingEnv ) {
		this.componentDecl = componentDecl;
		this.enclosingEnv = enclosingEnv;
		}

	public ComponentValue componentValue() {
		return this;
		}

	public boolean isComponent() {
		return true;
		}

	public boolean equals( Object other ) {
		if ( other == null )
			return false;
		if ( ! ( other instanceof RunValue ) )
			return false;
		RunValue runValue = ( RunValue ) other;
		if ( ! ( runValue instanceof ComponentValue ) )
			return false;
		ComponentValue otherComponentValue = ( ComponentValue ) runValue;
		return this == otherComponentValue;
		}

	public String toString() {
		return componentDecl.ident();
		}
	
	public void eval( 
		PathArrayValue[] inputParamValues,
		RunValue[] paramValues,
		PathArrayValue[] outputParamValues ) {
		componentDecl.invoke( enclosingEnv, 
			inputParamValues, paramValues, outputParamValues );
		}
	}
