package runEnv;
import java.util.*;

public class RunDecl {
	public final static int NONE			= 0;
	public final static int VALUE			= 1;
	public final static int PATH			= 2;
	public final static int COMPONENT		= 3;
	public final static int INPUTPARAM		= 4;
	public final static int OUTPUTPARAM		= 5;
	public final static int VALUEPARAM		= 6;

	public static String kindText( int kind ) {
		switch ( kind ) {
			case NONE:
				return "NONE";
			case VALUE:
				return "VALUE";
			case PATH:
				return "PATH";
			case COMPONENT:
				return "COMPONENT";
			case VALUEPARAM:
				return "VALUEPARAM";
			case INPUTPARAM:
				return "INPUTPARAM";
			case OUTPUTPARAM:
				return "OUTPUTPARAM";
			default:
				return "" + kind;
			}
		}

	private int kind;
	private String ident;
	private RunValue value;
	
	public int kind() { return kind; }
	public String kindText() { return kindText( kind ); }
	public String ident() { return ident; }
	public RunValue value() { return value; }
	
	public RunDecl( int kind, String ident, RunValue value ) {
		this.kind = kind;
		this.ident = ident;
		this.value = value;
//		System.err.println( this );
		}

	public String toString() { return "Declare " + kindText() + ":\t" + ident + "\t" + value; }
	}
