package runEnv.basicValue;

import runEnv.*;
 
public class IntValue extends BasicValue {
	private int value;

	public IntValue( int value ) {
		this.value = value;
		}

	public int intValue() {
		return value;
		}

	public String stringValue() {
		return "" + value;
		}
		
	public boolean isInt() {
		return true;
		}

	public boolean equals( Object other ) {
		if ( other == null )
			return false;
		if ( ! ( other instanceof RunValue ) )
			return false;
		RunValue runValue = ( RunValue ) other;
		if ( ! ( runValue instanceof IntValue ) )
			return false;
		IntValue otherIntValue = ( IntValue ) runValue;
		return value == otherIntValue.intValue();
		}

	public String toString() {
		return Integer.toString( value, 16 );
		}
	}
